UI-MVC/Models/AddBookViewModel.cs
using System.ComponentModel.DataAnnotations;
using EReader.BL.Domain;

namespace EReader.UI.Web.Models;

public class AddBookViewModel
{
    [Required]
    [StringLength(128, MinimumLength = 5)]
    public string BookTitle { get; set; }
    public BookFormat FormatOfBook { get; set; }

    /*public DateOnly? DatePublished { get; set; }*/
    public DateTime? DatePublished { get; set; }
}

UI-MVC/Models/ErrorViewModel.cs
namespace EReader.UI.Web.Models;

public class ErrorViewModel
{
    public string? RequestId { get; set; }

    public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
}

UI-MVC/Controllers/BookController.cs
using EReader.BL;
using EReader.BL.Domain;
using EReader.UI.Web.Models;
using Microsoft.AspNetCore.Mvc;

namespace EReader.UI.Web.Controllers;

// /Book
public class BookController : Controller
{
    private readonly IBookManager _bookManager;
    public BookController(IBookManager bookManager)
    {
        _bookManager = bookManager;
    }
    
    // GET /Book/Index
    public IActionResult Index()
    {
        // alle boeken tonen
        IEnumerable<Book> books = _bookManager.GetAllBooks();
        // (1) ViewData/ViewBag => sub-informatie
        //ViewBag.Books = books;
        // (2) ViewModel => hoofd-informatie
        return View(books);
    }

    // /Book/Add
    [HttpGet]
    public IActionResult Add()
    {
        return View();
    }
    [HttpPost]
    public IActionResult Add(AddBookViewModel book/*string title, BookFormat format*/)
    {
        bool isModelValid = ModelState.IsValid;
        if (!isModelValid)
            return View(book);
        
        // nieuw boek aanmaken
        Book createdBook = _bookManager.AddBook(book.BookTitle, book.FormatOfBook);
        
        //return View("AddConfirm", createdBook);
        return RedirectToAction("Index");
    }
}

UI-MVC/Controllers/HomeController.cs
using System.Diagnostics;
using EReader.UI.Web.Models;
using Microsoft.AspNetCore.Mvc;

namespace EReader.UI.Web.Controllers;

public class HomeController : Controller
{
    private readonly ILogger<HomeController> _logger;

    public HomeController(ILogger<HomeController> logger)
    {
        _logger = logger;
    }

    // https://localhost:62153/HomeController/Index
    // https://localhost:62153/Home/Index/15?key=value
    // https://localhost:62153/Home
    // https://localhost:62153/
    public IActionResult Index()
    {
        return View();
    }

    public IActionResult Privacy()
    {
        return View();
    }

    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public IActionResult Error()
    {
        return View(new ErrorViewModel {RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier});
    }
}

UI-MVC/Controllers/TestController.cs
using Microsoft.AspNetCore.Mvc;

namespace EReader.UI.Web.Controllers;

public class Test : Controller
{
    // GET https://...:.../Test/Index?key=value
    public string Index(int id, string key)
    {
        return $"{id}\t{key}";
    }
}

UI-MVC/Views/Book/Add.cshtml
@model AddBookViewModel

@{
    ViewBag.Title = "title";
}

<h2>Nieuw booek</h2>
<!--
<form @*action="/Book/Add"*@ asp-controller="Book" asp-action="Add" method="post">
    @*<input name="title"><br>*@
    <label asp-for="BookTitle"></label><input asp-for="BookTitle"><br>
    <span asp-validation-for="BookTitle" class="text-danger"></span><br>
    @*<input name="format" type="number"><br>*@
    <label asp-for="FormatOfBook"></label><input asp-for="FormatOfBook" type="number"><br>
    <span asp-validation-for="FormatOfBook" class="text-danger"></span><br>
    <button type="submit">Aanmaken</button>
    @*<input type="submit" value="Aanmaken">*@
</form>
-->
<partial name="_AddBookFormPartial" model="Model"/>

@*
@section Scripts
{
    <partial name="_ValidationScriptsPartial"/>
}
*@

UI-MVC/Views/Book/AddConfirm.cshtml
@using EReader.BL.Domain
@model EReader.BL.Domain.Book

@{
    ViewBag.Title = "title";
    Book book = Model;
}

<p>Boek @book.Title is aangemaakt!</p>

UI-MVC/Views/Book/Index.cshtml
@using EReader.BL.Domain
@model IEnumerable<Book>

@{
    ViewBag.Title = "Alle boeken"; // = ViewData["Title"] = "Alle boeken";
    // (1) ViewData/ViewBag
    //IEnumerable<Book> books = (IEnumerable<Book>) ViewBag.Books;
    // (2) ViewModel
    IEnumerable<Book> books = Model;
}

<h2>Alle boeken</h2>
<ul>
    @foreach (Book book in books)
    {
        <li>@book.Title</li>
    }
</ul>
<a @*href="/Book/Add"*@ @*asp-controller="Book"*@ asp-action="Add" class="btn">Nieuw boek</a>

<h2>Nieuw Book</h2>
<partial name="_AddBookFormPartial" model="null"/>

UI-MVC/Views/Book/_AddBookFormPartial.cshtml
@using EReader.BL.Domain
@model AddBookViewModel


<form @*action="/Book/Add"*@ asp-controller="Book" asp-action="Add" method="post">
    <div asp-validation-summary="All"></div>
    @*<input name="title"><br>*@
    <label asp-for="BookTitle"></label><input asp-for="BookTitle"><br>
    @*
    <span asp-validation-for="BookTitle" class="text-danger"></span><br>
    *@
    @*<input name="format" type="number"><br>*@
    <label asp-for="FormatOfBook"></label>
    @*<input asp-for="FormatOfBook" type="number"><br>*@
    @*<select asp-for="FormatOfBook">
        @foreach (string formatName in Enum.GetNames<BookFormat>())
        {
            <option value="@formatName">@formatName</option>
        }
    </select><br>*@
    <select asp-for="FormatOfBook" asp-items="new SelectList(Enum.GetNames<BookFormat>())"></select><br>
    @*
    <span asp-validation-for="FormatOfBook" class="text-danger"></span><br>
    *@
    
    <label asp-for="DatePublished"></label>
    <input asp-for="DatePublished" type="text" value="@Model?.DatePublished?.ToString("dd/MM/yyyy")" placeholder="format: dd/mm/jjjj"><br>
    
    <button type="submit">Aanmaken</button>
    @*<input type="submit" value="Aanmaken">*@
</form>

UI-MVC/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

UI-MVC/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <title>@ViewData["Title"] - UI_MVC</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css"/>
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true"/>
    <link rel="stylesheet" href="~/UI_MVC.styles.css" asp-append-version="true"/>
</head>
<body>
<header>
    <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
        <div class="container-fluid">
            <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">UI_MVC</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                    aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                <ul class="navbar-nav flex-grow-1">
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>
</header>
<div class="container">
    <main role="main" class="pb-3">
        @RenderBody()
    </main>
</div>

<footer class="border-top footer text-muted">
    <div class="container">
        &copy; 2022 - UI_MVC - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
    </div>
</footer>
<script src="~/lib/jquery/dist/jquery.min.js"></script>
<script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
<script src="~/js/site.js" asp-append-version="true"></script>
@await RenderSectionAsync("Scripts", required: false)
</body>
</html>